/*
* This file is part of Firestorm NIDS
* Copyright (c) 2001 Gianni Tedesco
*
*    Firestorm is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    Firestorm is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with Firestorm; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <lists.h>

/* Very slow insert operation */
void *list_append(void *vp, void *vstart)
{
	p_list_head p=(p_list_head)vp;
	p_list_head tmp=(p_list_head)vstart;
	
	if ( tmp ) {
		while(tmp->next)
			tmp=tmp->next;

		tmp->next = p;
		p->prev = tmp;
		p->next = NULL;
		return (void *)vstart;
	}else{
		p->prev = NULL;
		p->next = NULL;
		return (void *)p;
	}
}

/* depricated, use list_delete */
void *list_remove(void *p)
{
	p_list_head node=(p_list_head)p;

	if ( node->prev ) node->prev->next = node->next;
	if ( node->next ) node->next->prev = node->prev;
	return (void *)node;
}

void *list_delete(void *p, void **s)
{
	p_list_head node=(p_list_head)p;
	p_list_head *start=(p_list_head *)s;

	if ( node->next ) node->next->prev = node->prev;
	if ( node->prev ) {
		node->prev->next = node->next;
	}else{
		*start=node;
	}

	node->next=NULL;
	node->prev=NULL;
	return (void *)node;
}
